<template>
  <v-app>
    <main>
      <v-container fill-height>
        <v-layout row wrap align-center>
          <v-flex sm4 offset-sm4>
            <v-card>
              <v-card-title primary-title>
                <div class="text-xs-center">
                  <div class="subheading fw-300">Signup</div>
                  <div class="display-1 fw-300">Dayo</div>
                  <span class="deep-orange--text text--darken-3">Your Game. Your Time</span>
                </div>
              </v-card-title>
              <v-alert info :value="socialConnected">Nice! Please confirm signup.</v-alert>
              <v-alert error :value="error">{{error}}</v-alert>
              <v-form method="post" @submit.prevent="signUp" ref="signupForm">
                <v-card-text>
                  <v-text-field label="Name" v-model="user['full_name']" :rules="[$rules.required]" required></v-text-field>
                  <v-text-field label="Email" v-model="user['email']" :rules="[$rules.required, $rules.email]" required></v-text-field>
                  <v-text-field label="Password" type="password" v-model="user['password']" v-if="!socialConnected" :rules="[$rules.required]" required></v-text-field>
                  <v-text-field label="Repeat Password" type="password" v-model="user['repeatPassword']" v-if="!socialConnected" :rules="[$rules.required, (v) => v === user.password || 'Passwords doesn\'t match.']" required></v-text-field>
                  <v-text-field label="Mobile Number" v-model="user['mobile']" :rules="[$rules.required]" required></v-text-field>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions>
                  <v-btn flat primary type="submit">{{!socialConnected ? 'Signup' : 'Confirm Signup'}}</v-btn>
                  <v-btn flat to="/login" class="grey--text text--darken-2">I'm already registered</v-btn>
                </v-card-actions>
              </v-form>
            </v-card>
            <div class="mt-4 text-sm-center grey--text" v-if="!socialConnected">
              <p class="mb-0">Signup via</p>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Facebook' }" @click="connectSocial('facebook')">
                <img src="../assets/social-media-icons/003-facebook.png" alt="">
              </v-btn>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Twitter' }" @click="connectSocial('twitter')">
                <img src="../assets/social-media-icons/002-twitter.png" alt="">
              </v-btn>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Google+' }" @click="connectSocial('gplus')">
                <img src="../assets/social-media-icons/001-gplus.png" alt="">
              </v-btn>
            </div>
          </v-flex>
        </v-layout>
      </v-container>
    </main>
  </v-app>
</template>

<script>
  import firebase from 'firebase'

  export default {
    name: 'login',
    data () {
      return {
        uid: null,
        user: {role: 'merchant'},
        token: null,
        socialConnected: false,
        error: null
      }
    },
    methods: {
      connectSocial (type) {
        let provider = firebase.auth

        switch (type) {
          case 'facebook':
            provider = new provider.FacebookAuthProvider()
            break
          case 'gplus':
            provider = new provider.GoogleAuthProvider()
            break
          case 'twitter':
            provider = new provider.TwitterAuthProvider()
            break
        }

        firebase.auth().signInWithPopup(provider).then(result => {
          let user = result.user

          this.$database.ref(`users/${user.uid}`).once('value').then(snapshot => {
            let exist = snapshot.val()

            if (!exist) {
              this.uid = user.uid
              this.user = {
                full_name: user.displayName,
                email: user.email,
                mobile: user.phoneNumber,
                photo: user.photoURL
              }

              this.socialConnected = true
              this.error = null
            } else {
              this.error = 'This account already exist. Logging in...'
              setTimeout(() => this.$router.push({name: 'users'}), 3000)
            }
          })
        }).catch(error => {
          let {code, message} = error
          this.error = message
          console.log('error.code:', code)
        })
      },
      signUp () {
        if (this.$refs.signupForm.validate()) {
          let saveUser = uid => {
            delete this.user.password
            delete this.user.repeatPassword
            this.$database.ref(`users/${uid}`).set(this.user).then(() => {
              this.$store.commit('setState', {
                authenticated: true,
                user: firebase.auth().currentUser.toJSON()
              })
              this.$router.push({path: this.$route.params.ref || '/'})
            }).catch(function () { console.log(arguments) })
          }

          if (!this.socialConnected) {
            firebase.auth().createUserWithEmailAndPassword(this.user.email, this.user.password).then(user => {
              saveUser(user.uid)
            }).catch(({message}) => { this.error = message })
          } else saveUser(this.uid)
        }
      }
    },
    created () {
      if (this.$route.params.uid) {
        let {uid, user} = this.$route.params
        this.uid = uid
        this.user = user
        this.socialConnected = true
      }
    }
  }
</script>

<style scoped lang="stylus">
  @require '../../node_modules/vuetify/src/stylus/settings/_colors'

  .card__title div {
    width: 100%;
    color: $deep-orange.darken-3;
  }
</style>
